
var objSolRead = {
// Convert sol file to XML (Original converted to different XML format)
// Ported from http://osflash.org/s2x (Public Domain, No Licencing issues.)
// by Trevor Hobson
// Added Pointer data type - TH
	NUMBER: '\x00',
	BOOLEAN: '\x01',
	STRING: '\x02',
	OBJOBJ: '\x03',
	NULL: '\x05',
	UNDEF: '\x06',
	POINTER: '\x07',
	OBJARR: '\x08',
	//RAWARR: '\x0A',
	OBJDATE: '\x0B',
	OBJM: '\x0D',
	OBJXML: '\x0F',
	OBJCC: '\x10',
	FALSE3: '\x02',
	TRUE3: '\x03',
	NUMBER3: '\x04',
	STRING3: '\x06',

	contentDoc: null,
	contentDocData: null,
	count: 0,
	pointerTarget: 1,

	nsIDOMSerializer: Components.classes["@mozilla.org/xmlextras/xmlserializer;1"].createInstance(Components.interfaces.nsIDOMSerializer),

	read: function(solFile)
	{
		// Check to make sure a file was passed
		try
		{
			if (!solFile.isFile() || !solFile.exists())
			{
				return null;
			}
		} catch(err)
		{
			return null;
		}
		// Read the debug level for this session
		objSolGeneric.readDubugLevel();

		this.count = 0;
		this.pointerTarget = 1;
		this.contentDoc = Components.classes["@mozilla.org/xml/xml-document;1"].createInstance(Components.interfaces.nsIDOMDocument);
		this.contentDocData = this.contentDoc.createElement("data");
		this.contentDoc.appendChild(this.contentDocData);
		try
		{
			this.readSol(solFile);
			objSolGeneric.jsdump('objSolRead read:success:' + this.nsIDOMSerializer.serializeToString(this.contentDoc), 1);
			return this.contentDoc;
		} catch(err)
		{
			objSolGeneric.jsdump('objSolRead read:err:' + err, 1);
			return null;
		}
	},

	readSol: function(solFile)
	{
		// Open the file as a bitstream
		var istream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
		istream.init(solFile, -1, -1, false);

		var bstream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
		bstream.setInputStream(istream);

		var nLenFile = bstream.available();
		var sHeader = bstream.readBytes(2);
		var nLenData = bstream.read32(4); // (Unsigned) Long
		if (nLenFile != nLenData + 6)
		{
			this.elementAdd(this.count++, 'error', 'Data Length Mismatch', 'error', 0, false, 0, 0);
			return;
		}
		var sFileType = bstream.readBytes(4); // 'TCSO'
		var sth1 = bstream.readBytes(6);
		var nLenSoln = bstream.read16(2); // (Unsigned) Short
		var solname = bstream.readBytes(nLenSoln);
		var nVersion = bstream.read32(4); // (Unsigned) Long
		this.elementAdd(this.count++, 'name', solname, nVersion, 0, false, 0, 0);
		if (nVersion === 0)
		{
			var treeLevel = 0;
			try
			{
				while (bstream.available() > 0)
				{
					var nLenVname = bstream.read16(2); // (Unsigned) Short
					var sVname = bstream.readBytes(nLenVname);
					this.readStream(bstream, sVname, treeLevel, 0);
					var xEnd = bstream.readBytes(1); // '\x00'
				}
			} catch(err)
			{
				this.elementAdd(this.count++, 'error', sVname, 'error', treeLevel, false, 0, 0);
				bstream.close();
			}
		}
		// This bit is for the version 3 files. Not yet fully developed.
		/*
		else if (nVersion == 3)
		{
			var treeLevel = 0;
			try
			{
				while (bstream.available() > 0)
				{
					var sLenVname = bstream.readBytes(1); // Byte value determines length of name
					var nLenVname = Math.round((sLenVname.charCodeAt(0)/2)-.01);
					nLenVname = nLenVname.toFixed(0);
					var sVname = bstream.readBytes(nLenVname);
					this.v3readStream(bstream, sVname, treeLevel, nParent);
					var xEnd = bstream.readBytes(1); // '\x00'
				}
			} catch(err)
			{
				this.elementAdd(this.count++, 'error', sVname, 'error', treeLevel, false, 0, 0);
				bstream.close();
			}
		}
		*/
		else
		{
			this.elementAdd(this.count++, 'version', 'Not yet supported sol format', nVersion, treeLevel, false, 0, 0);
		}
		bstream.close();
	},

	readStream: function(bstream, sVname, treeLevel, nParent)
	{
		var xType = bstream.readBytes(1);
		if (xType == this.NUMBER)
		{
			this.num2a(bstream, sVname, treeLevel, nParent);
		}
		else if (xType == this.BOOLEAN)
		{
			this.bol2a(bstream, sVname, treeLevel, nParent);
		}
		else if (xType == this.STRING)
		{
			this.str2a(bstream, sVname, treeLevel, nParent);
		}
		else if (xType == this.OBJOBJ)
		{
			this.obj2a(bstream, sVname, treeLevel, nParent);
		}
		else if (xType == this.OBJARR)
		{
			this.arr2a(bstream, sVname, treeLevel, nParent);
		}
		else if (xType == this.OBJDATE)
		{
			this.dat2a(bstream, sVname, treeLevel, nParent);
		}
		else if (xType == this.OBJXML)
		{
			this.xml2a(bstream, sVname, treeLevel, nParent);
		}
		else if (xType == this.OBJCC)
		{
			this.occ2a(bstream, sVname, treeLevel, nParent);
		}
		else if (xType == this.OBJM)
		{
			this.ojm2a(bstream, sVname, treeLevel, nParent);
		}
		else if (xType == this.POINTER)
		{
			this.ptr2a(bstream, sVname, treeLevel, nParent);
		}
		else if (xType == this.NULL)
		{
			this.nul2a(bstream, sVname, treeLevel, nParent);
		}
		else if (xType == this.UNDEF)
		{
			this.und2a(bstream, sVname, treeLevel, nParent);
		}
		else
		{
			var xTypeHex = xType.charCodeAt(0).toString(16);
			this.elementAdd(this.count++, 'error', sVname, xTypeHex, treeLevel, false, 0, nParent);
		}
	},

	elementAdd: function(eleNumber, eleType, eleName, eleValue, eleLevel, eleContainer, eleTarget, eleParent)
	{
		var elementNew = this.contentDoc.createElement("element");
		elementNew.setAttribute("number", eleNumber);
		elementNew.setAttribute("name", eleName);
		elementNew.setAttribute("type", eleType);
		elementNew.setAttribute("level", eleLevel);
		elementNew.setAttribute("target", eleTarget);
		elementNew.setAttribute("container", eleContainer);
		elementNew.setAttribute("parent", eleParent);
		var elementValue = this.contentDoc.createTextNode(eleValue);
		elementNew.appendChild(elementValue);
		this.contentDocData.appendChild(elementNew);
	},

	num2a: function(bstream, sVname, treeLevel, nParent)
	{
		var sValue = '';
		try
		{
			var s = bstream.readDouble(8); // Double
			sValue = String(s);
		} catch(err)
		{
			sValue = 'error';
		}
		this.elementAdd(this.count++, 'number', sVname, sValue, treeLevel, false, 0, nParent);
	},

	bol2a: function(bstream, sVname, treeLevel, nParent)
	{
		var b = bstream.readBytes(1);
		var sValue = '';
		if (b == '\x00')
		{
			sValue = 'false';
		}
		else if (b == '\x01')
		{
			sValue = 'true';
		}
		else
		{
			sValue = 'error';
		}
		this.elementAdd(this.count++, 'boolean', sVname, sValue, treeLevel, false, 0, nParent);
	},

	str2a: function(bstream, sVname, treeLevel, nParent)
	{
		var nLenStr = bstream.read16(2); // (Unsigned) Short
		var sValue = bstream.readBytes(nLenStr);
		this.elementAdd(this.count++, 'string', sVname, sValue, treeLevel, false, 0, nParent);
	},

	obj2a: function(bstream, sVname, treeLevel, nParent)
	{
		var nCount = this.count;
		this.elementAdd(this.count++, 'object', sVname, '', treeLevel, true, this.pointerTarget++, nParent);
		var nLenVname = bstream.read16(2); // (Unsigned) Short
		while (nLenVname !== 0)
		{
			sVname = bstream.readBytes(nLenVname);
			this.readStream(bstream, sVname, treeLevel + 1, nCount);
			nLenVname = bstream.read16(2); // (Unsigned) Short
		}
		var xEndObj = bstream.readBytes(1); // '\x09'
	},

	arr2a: function(bstream, sVname, treeLevel, nParent)
	{
		var nCount = this.count;
		var nArrLength = bstream.read32(4); // (Unsigned) Long
		this.elementAdd(this.count++, 'array', sVname, '', treeLevel, true, this.pointerTarget++, nParent);
		var nLenVname = bstream.read16(2); // (Unsigned) Short
		while (nLenVname !== 0)
		{
			sVname = bstream.readBytes(nLenVname);
			this.readStream(bstream, sVname, treeLevel + 1, nCount);
			nLenVname = bstream.read16(2); // (Unsigned) Short
		}
		var xEndObj = bstream.readBytes(1); // '\x09'
	},

	dat2a: function(bstream, sVname, treeLevel, nParent)
	{
		var nMsec = bstream.readDouble(8); // Double
		var nMinOffset = bstream.read16(2); // (Signed) Short - Does not read negative as short so need to convert it
		if (nMinOffset > 0x7fff)
		{
			nMinOffset = ~(0x10000 - nMinOffset - 1);
		}
		var nOffset = nMinOffset/60;
		var sOffsetSign = (nOffset <= 0) ? '+' : ''; // Create a + for positive offset
		var sOffset = sOffsetSign + String(-nOffset);
		var nDate = new Date(Date.UTC(1969,12,1) + nMsec); // Create a date starting at Dec 1 1969
		var sDate = nDate.getUTCFullYear() + '-' + (nDate.getUTCMonth()+1) + '-' + nDate.getUTCDate() + ' ' + nDate.getUTCHours() + ':' + nDate.getUTCMinutes() + ':' + nDate.getUTCSeconds() + '.' + nDate.getUTCMilliseconds() + ' UTC ' + sOffset;
		this.elementAdd(this.count++, 'date', sVname, sDate, treeLevel, false, 0, nParent);
	},

	xml2a: function(bstream, sVname, treeLevel, nParent)
	{
		var nLenCData = bstream.read32(4); // (Unsigned) Long
		var sCData = bstream.readBytes(nLenCData);
		this.elementAdd(this.count++, 'xml', sVname, sCData, treeLevel, false, 0, nParent);
	},

	occ2a: function(bstream, sVname, treeLevel, nParent)
	{
		var nCount = this.count;
		var nLenCname = bstream.read16(2); // (Unsigned) Short
		var sCname = bstream.readBytes(nLenCname);
		this.elementAdd(this.count++, 'c_object', sVname, sCname, treeLevel, true, this.pointerTarget++, nParent);
		var nLenVname = bstream.read16(2); // (Unsigned) Short
		while (nLenVname !== 0)
		{
			sVname = bstream.readBytes(nLenVname);
			this.readStream(bstream, sVname, treeLevel + 1, nCount);
			nLenVname = bstream.read16(2); // (Unsigned) Short
		}
		var xEndObj = bstream.readBytes(1); // '\x09'
	},

	ojm2a: function(bstream, sVname, treeLevel, nParent)
	{
		this.elementAdd(this.count++, 'm_object', sVname, '', treeLevel, false, this.pointerTarget++, nParent);
	},

	ptr2a: function(bstream, sVname, treeLevel, nParent)
	{
		var nPointer = bstream.read16(2); // (Unsigned) Short
		var sPointer = String(nPointer);
		this.elementAdd(this.count++, 'pointer', sVname, sPointer, treeLevel, false, 0, nParent);
	},

	nul2a: function(bstream, sVname, treeLevel, nParent)
	{
		this.elementAdd(this.count++, 'null', sVname, '', treeLevel, false, 0, nParent);
	},

	und2a: function(bstream, sVname, treeLevel, nParent)
	{
		this.elementAdd(this.count++, 'undefined', sVname, '', treeLevel, false, 0, nParent);
	},

	v3readStream: function(bstream, sVname, treeLevel, nParent)
	{
		var xType = bstream.readBytes(1);
		if (xType == this.FALSE3)
		{
			this.v3bol2a('false', sVname, treeLevel, nParent);
		}
		else if (xType == this.TRUE3)
		{
			this.v3bol2a('true', sVname, treeLevel, nParent);
		}
		if (xType == this.NUMBER3)
		{
			this.v3num2a(bstream, sVname, treeLevel, nParent);
		}
		else if (xType == this.STRING3)
		{
			this.v3str2a(bstream, sVname, treeLevel, nParent);
		}
		else
		{
			var xTypeHex = xType.charCodeAt(0).toString(16);
			this.elementAdd(this.count++, 'error', sVname, xTypeHex, treeLevel, false, 0, nParent);
		}
	},

	v3bol2a: function(sValue, sVname, treeLevel, nParent)
	{
		this.elementAdd(this.count++, 'boolean', sVname, sValue, treeLevel, false, 0, nParent);
	},

	v3num2a: function(bstream, sVname, treeLevel, nParent)
	{
		var sPart = bstream.readBytes(1);
		var nPart = sPart.charCodeAt(0);
		var sValue = this.padHex(nPart.toString(16));
		while (nPart > 128)
		{
			sPart = bstream.readBytes(1);
			nPart = sPart.charCodeAt(0);
			sValue += this.padHex(nPart.toString(16));
		}
		this.elementAdd(this.count++, 'number', sVname, sValue, treeLevel, false, 0, nParent);
	},

	v3str2a: function(bstream, sVname, treeLevel, nParent)
	{
		var sLenStr = bstream.readBytes(1); // Byte value determines length of string
		var nLenStr = Math.floor(sLenStr.charCodeAt(0)/2);
		var sValue = bstream.readBytes(nLenStr);
		this.elementAdd(this.count++, 'string', sVname, sValue, treeLevel, false, 0, nParent);
	},

	padHex: function(stringHex)
	{
		return (stringHex.length > 1) ? stringHex : '0' + stringHex;
	}
};

var objSolWrite = {
// Convert XML to sol file (Original converted from different XML format)
// Ported from http://osflash.org/s2x (Public Domain, No Licencing issues.)
// by Trevor Hobson
// Added Pointer data type - TH
	NUMBER: '\x00',
	BOOLEAN: '\x01',
	STRING: '\x02',
	OBJOBJ: '\x03',
	NULL: '\x05',
	UNDEF: '\x06',
	POINTER: '\x07',
	OBJARR: '\x08',
	//RAWARR: '\x0A',
	OBJDATE: '\x0B',
	OBJM: '\x0D',
	OBJXML: '\x0F',
	OBJCC: '\x10',
	contentDoc: null,
	contentDocData: null,
	contentDocElement: [],
	countElement: 0,
	count: 0,

	nsIDOMSerializer: Components.classes["@mozilla.org/xmlextras/xmlserializer;1"].createInstance(Components.interfaces.nsIDOMSerializer),

	writer: function(solXml, solFile)
	{
		// Read the debug level for this session
		objSolGeneric.readDubugLevel();

		// If we have been passed XML in a valid format, process
		var returnResult = null;
		try
		{
			this.contentDoc = solXml;
			this.contentDocElement = [];
			var xpe = Components.classes["@mozilla.org/dom/xpath-evaluator;1"].createInstance(Components.interfaces.nsIDOMXPathEvaluator);
			var nsResolver = xpe.createNSResolver(this.contentDoc);
			var result = xpe.evaluate('//data/element', this.contentDoc, nsResolver, 0, null);
			result.QueryInterface(Components.interfaces.nsIDOMXPathResult);  // not necessary in FF3, only 2.x and possibly earlier
			var res;
			while (res = result.iterateNext())
			{
				this.contentDocElement.push(res);
			}
			if (this.contentDocElement.length > 0)
			{
				if (this.contentDocElement[0].getAttribute('type') == 'name')
				{
					returnResult = this.writeSol(solFile)
				}
			}
		}
		catch(err)
		{
			objSolGeneric.jsdump('objSolWrite write:err:' + err, 1);
		}
		return returnResult;
	},

	writeSol: function(solFile)
	{
		// Create storage stream (temporary stream to hold content)
		var sstream = Components.classes["@mozilla.org/storagestream;1"].createInstance(Components.interfaces.nsIStorageStream);
		sstream.init(128, -1, null);

		var bstreamSO = Components.classes["@mozilla.org/binaryoutputstream;1"].createInstance(Components.interfaces.nsIBinaryOutputStream);
		bstreamSO.setOutputStream(sstream);

		bstreamSO.writeBytes('TCSO', 4); // sFileType
		bstreamSO.writeBytes('\x00\x04\x00\x00\x00\x00', 6); // sth1
		var solname = this.contentDocElement[0].getAttribute('name');
		var nLenSoln = solname.length;
		bstreamSO.write16(nLenSoln);
		bstreamSO.writeBytes(solname, nLenSoln);
		bstreamSO.writeBytes('\x00\x00\x00\x00', 4); // sth2

		var isError = false;
		this.countElement = 1;
		while (this.countElement < this.contentDocElement.length && isError === false)
		{
			isError = this.makeStream(bstreamSO);
			if (!isError)
			{
				bstreamSO.writeBytes('\x00', 1);
			}
			this.countElement++;
		}
		if (isError === true)
		{
			sstream.close;
			return null;
		}

		// Create input stream to read storage stream
		var istreamS = sstream.newInputStream(0);
		var bstreamSI = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
		bstreamSI.setInputStream(istreamS);

		nLenData = bstreamSI.available();
		var sData = bstreamSI.readByteArray(nLenData);

		// Close the storage stream as we don't need it any more
		sstream.close;

		// Create the file if it does not exist
		if (!solFile.exists())
		{
			solFile.create(0,0666);
		}
		// Open the file as an output stream
		var ostream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		ostream.init(solFile,-1, -1, false);
		var bstreamO = Components.classes["@mozilla.org/binaryoutputstream;1"].createInstance(Components.interfaces.nsIBinaryOutputStream);
		bstreamO.setOutputStream(ostream);

		bstreamO.writeBytes('\x00\xBF', 2); // sHeader
		bstreamO.write32(nLenData);
		bstreamO.writeByteArray(sData, nLenData);

		ostream.close();
		return true;
	},

	makeStream: function(bstreamSO)
	{
		var sVname = this.contentDocElement[this.countElement].getAttribute('name');
		var nLenVname = sVname.length;
		bstreamSO.write16(nLenVname);
		bstreamSO.writeBytes(sVname, nLenVname);

		var isError = false;
		var aType = this.contentDocElement[this.countElement].getAttribute('type');
		if (aType == 'number')
		{
			isError = this.a2num(bstreamSO);
		}
		else if (aType == 'boolean')
		{
			isError = this.a2bol(bstreamSO);
		}
		else if (aType == 'string')
		{
			isError = this.a2str(bstreamSO);
		}
		else if (aType == 'object')
		{
			isError = this.a2obj(bstreamSO);
		}
		else if (aType == 'array')
		{
			isError = this.a2arr(bstreamSO);
		}
		else if (aType == 'date')
		{
			isError = this.a2dat(bstreamSO);
		}
		else if (aType == 'xml')
		{
			isError = this.a2xml(bstreamSO);
		}
		else if (aType == 'c_object')
		{
			isError = this.a2occ(bstreamSO);
		}
		else if (aType == 'm_object')
		{
			isError = this.a2ojm(bstreamSO);
		}
		else if (aType == 'pointer')
		{
			isError = this.a2ptr(bstreamSO);
		}
		else if (aType == 'null')
		{
			isError = this.a2nul(bstreamSO);
		}
		else if (aType == 'undefined')
		{
			isError = this.a2und(bstreamSO);
		}
		else
		{
			isError = true;
		}
		return isError;
	},

	a2num: function(bstreamSO)
	{
		bstreamSO.writeBytes(this.NUMBER, 1);
		var isError = false;
		var sValue = this.contentDocElement[this.countElement].firstChild.nodeValue;
		if (sValue == 'Infinity')
		{
			bstreamSO.writeBytes('\x7F\xF0\x00\x00\x00\x00\x00\x00', 8);
		}
		else if (sValue == '-Infinity')
		{
			bstreamSO.writeBytes('\xFF\xF0\x00\x00\x00\x00\x00\x00', 8);
		}
		else if (sValue == 'NaN')
		{
			bstreamSO.writeBytes('\x7F\xF8\x00\x00\x00\x00\x00\x00', 8);
		}
		else if (sValue == 'error')
		{
			isError = true;
		}
		else
		{
			bstreamSO.writeDouble(sValue);
		}
		return isError;
	},

	a2bol: function(bstreamSO)
	{
		bstreamSO.writeBytes(this.BOOLEAN, 1);
		var isError = false;
		var sValue = this.contentDocElement[this.countElement].firstChild.nodeValue;
		if (sValue == 'true')
		{
			bstreamSO.writeBytes('\x01', 1);
		}
		else if (sValue == 'false')
		{
			bstreamSO.writeBytes('\x00', 1);
		}
		else
		{
			isError = true;
		}
		return isError;
	},

	a2str: function(bstreamSO)
	{
		bstreamSO.writeBytes(this.STRING, 1);
		var isError = false;
		var sValue = this.contentDocElement[this.countElement].firstChild.nodeValue;
		if (sValue == 'error')
		{
			isError = true;
		}
		else
		{
			var nLenStr = sValue.length;
			bstreamSO.write16(nLenStr);
			bstreamSO.writeBytes(sValue, nLenStr);
		}
		return isError;
	},

	a2obj: function(bstreamSO)
	{
		bstreamSO.writeBytes(this.OBJOBJ, 1);
		var isError = false;
		var sValue = this.contentDocElement[this.countElement].firstChild.nodeValue;
		if (sValue == 'error')
		{
			isError = true;
		}
		else
		{
			var level = this.contentDocElement[this.countElement].getAttribute('level');
			this.countElement++;
			while (this.countElement < this.contentDocElement.length && this.contentDocElement[this.countElement].getAttribute('level') > level && isError === false)
			{
				isError = this.makeStream(bstreamSO);
				this.countElement++;
			}
			this.countElement--;
			if (!isError)
			{
				bstreamSO.writeBytes('\x00\x00\x09', 3);
			}
		}
		return isError;
	},

	a2arr: function(bstreamSO)
	{
		bstreamSO.writeBytes(this.OBJARR, 1);
		var isError = false;
		var sValue = this.contentDocElement[this.countElement].firstChild.nodeValue;
		if (sValue == 'error')
		{
			isError = true;
		}
		else
		{
			var level = this.contentDocElement[this.countElement].getAttribute('level');
			var countArray = this.countElement + 1;
			var nArrLength = 0;
			while (countArray < this.contentDocElement.length && this.contentDocElement[countArray].getAttribute('level') > level)
			{
				if (this.contentDocElement[countArray].getAttribute('level') == level + 1)
				{
					nArrLength++;
				}
				countArray++;
			}
			bstreamSO.write32(nArrLength);
			this.countElement++;
			while (this.countElement < this.contentDocElement.length && this.contentDocElement[this.countElement].getAttribute('level') > level && isError === false)
			{
				isError = this.makeStream(bstreamSO);
				this.countElement++;
			}
			this.countElement--;
			if (!isError)
			{
				bstreamSO.writeBytes('\x00\x00\x09', 3);
			}
		}
		return isError;
	},

	a2dat: function(bstreamSO)
	{
		bstreamSO.writeBytes(this.OBJDATE, 1);
		var isError = false;
		var sValue = this.contentDocElement[this.countElement].firstChild.nodeValue;
		if (sValue == 'error')
		{
			isError = true;
		}
		else
		{
			var sDate = sValue.match(/.*(?=\sUTC)/i);
			var nDate = Date.parse(sDate);
			var sOffset = sValue.match(/UTC.*/i).replace(/UTC/i,'');
			var nMinOffset = parseInt(sOffset, 10) * -60;
			bstreamSO.writeDouble(nDate);
			bstreamSO.write16(nMinOffset);
		}
		return isError;
	},

	a2xml: function(bstreamSO)
	{
		bstreamSO.writeBytes(this.OBJXML, 1);
		var isError = false;
		var sValue = this.contentDocElement[this.countElement].firstChild.nodeValue;
		if (sValue == 'error')
		{
			isError = true;
		}
		else
		{
			var nLenXml = sValue.length;
			bstreamSO.write32(nLenXml);
			bstreamSO.writeBytes(sValue, nLenXml);
		}
	},

	a2occ: function(bstreamSO)
	{
		bstreamSO.writeBytes(this.OBJCC, 1);
		var isError = false;
		var sValue = this.contentDocElement[this.countElement].firstChild.nodeValue;
		if (sValue == 'error')
		{
			isError = true;
		}
		else
		{
			var level = this.contentDocElement[this.countElement].getAttribute('level');;
			this.countElement++;
			while (this.countElement < this.contentDocElement.length && this.contentDocElement[this.countElement].getAttribute('level') > level && isError === false)
			{
				isError = this.makeStream(bstreamSO);
				this.countElement++;
			}
			this.countElement--;
			if (!isError)
			{
				bstreamSO.writeBytes('\x00\x00\x09', 3);
			}
		}
		return isError;
	},

	a2ojm: function(bstreamSO)
	{
		bstreamSO.writeBytes(this.OBJM, 1);
		var isError = false;
		var sValue = this.contentDocElement[this.countElement].firstChild.nodeValue;
		if (sValue == 'error')
		{
			isError = true;
		}
		return isError;
	},

	a2ptr: function(bstreamSO)
	{
		bstreamSO.writeBytes(this.POINTER, 1);
		var isError = false;
		var sValue = this.contentDocElement[this.countElement].firstChild.nodeValue;
		if (sValue == 'error')
		{
			isError = true;
		}
		else
		{
			bstreamSO.write16(sValue);
		}
		return isError;
	},

	a2nul: function(bstreamSO)
	{
		bstreamSO.writeBytes(this.NULL, 1);
		var isError = false;
		var sValue = this.contentDocElement[this.countElement].firstChild.nodeValue;
		if (sValue == 'error')
		{
			isError = true;
		}
		return isError;
	},

	a2und: function(bstreamSO)
	{
		bstreamSO.writeBytes(this.UNDEF, 1);
		var isError = false;
		var sValue = this.contentDocElement[this.countElement].firstChild.nodeValue;
		if (sValue == 'error')
		{
			isError = true;
		}
		return isError;
	}

};

var objSolGeneric = {

	debugLevel: 10,

	readDubugLevel: function()
	{
		this.debugLevel = 10;
		try {this.debugLevel = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.objection.").getIntPref("debugLevel");}catch (err) {}
	},

	jsdump: function(str, level)
	{
		if (level >= this.debugLevel)
		{
  			Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService).logStringMessage(str);
		}
	}
};

/***********************************************************
XPCOM
***********************************************************/

/***********************************************************
constants
***********************************************************/

// reference to the interface defined in nsISolRequest.idl
const nsISolRequest = Components.interfaces.nsISolRequest;

// reference to the required base interface that all components must support
const nsISupports = Components.interfaces.nsISupports;

// UUID uniquely identifying our component
// You can get from: http://kruithof.xs4all.nl/uuid/uuidgen here
const CLASS_ID = Components.ID("{c88bf230-60fd-11dd-ad8b-0800200c9a66}");

// description
const CLASS_NAME = "Sol Request Javascript XPCOM Component";

// textual unique identifier
const CONTRACT_ID = "@objection/solrequest;1";

/***********************************************************
class definition
***********************************************************/

//class constructor
function SolRequest() {
	// If you only need to access your component from Javascript, uncomment the following line:
	this.wrappedJSObject = this;
};

// class definition
SolRequest.prototype = {

  // define the functions we want to expose in our interface
  solRead: function(solFile) {
      return objSolRead.read(solFile);
  },

  solWrite: function(solXML, solFile) {
	  return objSolWrite.writer(solXML, solFile);
  },

  QueryInterface: function(aIID)
  {
    if (!aIID.equals(nsISolRequest) &&
        !aIID.equals(nsISupports))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  }
};

/***********************************************************
class factory

This object is a member of the global-scope Components.classes.
It is keyed off of the contract ID. Eg:

// mySolRequest = Components.classes["@objection/solrequest;1"].createInstance(Components.interfaces.nsISolRequest);

mySolRequest = Components.classes['@objection/solrequest;1'].getService().wrappedJSObject;

***********************************************************/
var SolRequestFactory = {
  createInstance: function (aOuter, aIID)
  {
    if (aOuter != null)
      throw Components.results.NS_ERROR_NO_AGGREGATION;
    return (new SolRequest()).QueryInterface(aIID);
  }
};

/***********************************************************
module definition (xpcom registration)
***********************************************************/
var SolRequestModule = {
  registerSelf: function(aCompMgr, aFileSpec, aLocation, aType)
  {
    aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, CONTRACT_ID, aFileSpec, aLocation, aType);
  },

  unregisterSelf: function(aCompMgr, aLocation, aType)
  {
    aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);
  },

  getClassObject: function(aCompMgr, aCID, aIID)
  {
    if (!aIID.equals(Components.interfaces.nsIFactory))
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    if (aCID.equals(CLASS_ID))
      return SolRequestFactory;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  canUnload: function(aCompMgr) { return true; }
};

/***********************************************************
module initialization

When the application registers the component, this function
is called.
***********************************************************/
function NSGetModule(aCompMgr, aFileSpec) { return SolRequestModule; }
